function theta = GaussNewton(z, Xsample)
    % Carries out nonlinear regression via Gauss-Newton
p = 2;
b = ones(p,1);
n = length(z);
iter = 0;
b0 = [ones(n,1) 1./Xsample]\(1./z);
theta0 = [1/b0(1); b0(2)/b0(1)];
theta = theta0;

while norm(b) > .01 && iter < 20
    [F, ~, ~] = decomp(theta, Xsample, 0);
    y = z - eta(theta, Xsample);
    num = rcond(F'*F);
    if num > 1e-4
        b = F\y; %regress(y,F); or pinv(F)*y
    else
        disp(['n = ', num2str(n), '  rcond = ', num2str(num)]);
        b = zeros(p,1);
    end
    b_iter = 0;
    SS0 = norm(y)^2;
    SS = SS0;
    while b_iter <= 5 && SS >= SS0 
        % Guard against 'overshooting'; keep reducing the increment 
        % until SS drops
        mult = .5^(b_iter);
        theta2 = max(mult*b + theta,0);
        SS = norm(z - eta(theta2, Xsample))^2;
        b_iter = b_iter + 1;
     end
    theta = theta2;
    iter = iter + 1;
end


