function [F, Q, Qcomp] = decomp(theta, X, Qtoo) 
    % forms the F and Q matrices for given parameter theta (in nonlinear
    % models) and independent variables X
F =  [X./(theta(2) + X) -theta(1)*X./((theta(2) + X).^2)];
if Qtoo == 1
    [Qfull,~] = qr(F);
    N = size(F,1);
    p = size(F,2);
    Q = Qfull(:,1:p);
    Qcomp = Qfull(:,(p+1):N);
else
    Q = [];
    Qcomp = [];
end
